---
title: Notable bugs fixed in Firefox 3
slug: Mozilla/Firefox/Releases/3/Notable_bugs_fixed
tags:
  - Firefox 3
---
<div>{{FirefoxSidebar}}</div>

<p>This article offers a list of important bug fixes offered by Firefox 3 that are not necessarily obvious in the documentation.</p>

<ul>
 <li>if an error occurs parsing an overlay, the overlay is not applied. Parse errors are logged to the error console. ({{ Bug(335755) }})</li>
 <li>bug fixed where <code>&lt;menupopup&gt;</code> elements can be placed inside a binding when attached to a menu or menu-like element. ({{ Bug(345896) }})</li>
 <li>the button's <code>dlgType</code> property now works properly. ({{ Bug(308591) }})</li>
 <li>the <code>canBubble</code> argument to {{ Domxref("event.initEvent") }} now works properly so that events can be fired which don't bubble. ({{ Bug(330190) }})</li>
 <li>the <code>DOMAttrModified</code> event now handles namespaced attributes properly. ({{ Bug(362391) }})</li>
 <li>XML processing instructions, such as <code>&lt;?xml-stylesheet ?&gt;</code>, are now added to a XUL document's DOM. This means {{ Domxref("document.firstChild") }} isn't guaranteed to be the root element, use {{ Domxref("document.documentElement") }} instead. Also, <code>&lt;?xml-stylesheet ?&gt;</code> and <code>&lt;?xul-overlay ?&gt;</code> processing instructions now have no effect outside the document prolog. ({{ Bug(319654) }})</li>
 <li><span id="m-getElementsByAttributeNS"><code><a href="/en-US/docs/Mozilla/Tech/XUL/Method/getElementsByAttributeNS">getElementsByAttributeNS()</a></code></span> functions have been added to XUL elements and documents. ({{ Bug(239976) }})</li>
 <li>event listeners are maintained when moving or removing an element from a XUL document. ({{ Bug(286619) }})</li>
 <li>mutation events are now fired for non-displayed documents. ({{ Bug(201236) }})</li>
 <li>various issues with elements drawing in the wrong order are fixed. ({{ Bug(317375) }})</li>
 <li><code><a href="/en/DOM/element.getElementsByTagName" title="en/DOM/element.getElementsByTagName">getElementsByTagName()</a></code> has been fixed to work correctly on subtrees that have elements with namespace prefixes in their tag names ({{ Bug(206053) }}).</li>
 <li>The <code>DOMNodeInserted</code> and <code>DOMNodeRemoved</code> events now properly apply to the correct nodes ({{ Bug(367164) }}).</li>
 <li><code>\d</code>, one of special characters in regular expressions, has been fixed to match only Basic Latin alphabet digits (equivalent to <code>{{ mediawiki.external('0-9') }}</code>). ({{ Bug(378738) }})</li>
 <li>The image-sniffing-services category allows for image decoders implemented as extensions to correctly decode images sent with incorrect mime-types. ({{ Bug(391667) }})</li>
 <li>Right-clicks on form controls no longer brings up a context menu by default ({{ Bug(404536) }}.  See <a class="internal" href="/en/Offering%20a%20context%20menu%20for%20form%20controls" title="en/Offering a context menu for form controls">Offering a context menu for form controls</a> to learn how to enable this on a case-by-case basis.</li>
</ul>

<h3 id="See_also">See also</h3>

<ul>
 <li><a href="/en/Firefox_3_for_developers" title="en/Firefox_3_for_developers">Firefox 3 for developers</a></li>
</ul>
